PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Protected Member Functions | Protected Attributes | List of all members
PAbstractSortedList Class Reference

This class is a collection of objects which are descendents of the `PObject` class. More...

`#include <lists.h>`

Inheritance diagram for PAbstractSortedList:
[legend]
Collaboration diagram for PAbstractSortedList:
[legend]

## Public Member Functions
Construction
| PAbstractSortedList ()
| Create a new, empty, sorted list. More...
Overrides from class PObject
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two lists. More...
Overrides from class PContainer
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for lists. More...
Overrides from class PCollection
virtual PINDEX | Append (PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Add a new object to the collection. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| This method simply returns false as the list order is mantained by the class. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
void | RemoveElement (PSortedListElement *node)
void | LeftRotate (PSortedListElement *node)
void | RightRotate (PSortedListElement *node)
void | DeleteSubTrees (PSortedListElement *node, bool deleteObject)
PSortedListElement * | FindElement (const PObject &obj, PINDEX *index) const
PSortedListElement * | FindElement (const PObject *obj, PINDEX *index) const
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes
PSortedListInfo * | m_info

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Friends inherited from PObject

## Detailed Description

This class is a collection of objects which are descendents of the `PObject` class.

It is implemeted as a Red-Black binary tree to maintain the objects in rank order. Note that this requires that the `PObject::Compare()` function be fully implemented oin objects contained in the collection.

The implementation of a sorted list allows fast inserting and deleting as well as random access of objects in the collection. As the objects are being kept sorted, "fast" is a relative term. All operations take o(lg n) unless a particular object is repeatedly accessed.

The class remembers the last accessed element. This state information is used to optimise access by the "virtual array" model of collections. If repeated access via ordinal index is made there is little overhead. All other access incurs a minimum overhead, but not insignificant.

The PAbstractSortedList class would very rarely be descended from directly by the user. The `PDECLARE_LIST` and `PLIST` macros would normally be used to create descendent classes. They will instantiate the template based on `PSortedList` or directly declare and define the class (using inline functions) if templates are not being used.

The `PSortedList` class or `PDECLARE_SORTED_LIST` macro will define the correctly typed operators for subscript access (operator[]).

## Constructor & Destructor Documentation

PAbstractSortedList::PAbstractSortedList | ( |  | ) |

Create a new, empty, sorted list.

Note that by default, objects placed into the list will be deleted when removed or when all references to the list are destroyed.

## Member Function Documentation

virtual PINDEX PAbstractSortedList::Append | ( | PObject * | obj | ) |
| virtual

Add a new object to the collection.

The object is always placed in the correct ordinal position in the list. It is not placed at the "end".

Returns
  index of the newly added object.

Implements PCollection.

virtual Comparison PAbstractSortedList::Compare | ( | const PObject & | obj | ) | const
| virtual

Get the relative rank of the two lists.

The following algorithm is employed for the comparison:

- `EqualTo` if the two lists are identical in length and each objects values, not pointer, are equal.

- `LessThan` if the instances object value at an ordinal position is less than the corresponding objects value in the `obj` parameters list.

This is also returned if all objects are equal and the instances list length is less than the `obj` parameters list length.

- `GreaterThan` if the instances object value at an ordinal position is greater than the corresponding objects value in the `obj` parameters list.

This is also returned if all objects are equal and the instances list length is greater than the `obj` parameters list length.

Returns
  comparison of the two objects, `EqualTo` for same, `LessThan` for `obj` logically less than the object and `GreaterThan` for `obj` logically greater than the object.

Reimplemented from PObject.

void PAbstractSortedList::DeleteSubTrees | ( | PSortedListElement * | node,
|  | bool | deleteObject
| ) |  |
| protected

PSortedListElement* PAbstractSortedList::FindElement | ( | const PObject & | obj,
|  | PINDEX * | index
| ) |  | const
| protected

Referenced by PSortedList< T >::find().

PSortedListElement* PAbstractSortedList::FindElement | ( | const PObject * | obj,
|  | PINDEX * | index
| ) |  | const
| protected

virtual PObject* PAbstractSortedList::GetAt | ( | PINDEX | index | ) | const
| virtual

Get the object at the specified ordinal position.

If the index was greater than the size of the collection then NULL is returned.

Returns
  pointer to object at the specified index.

Implements PCollection.

Referenced by PSortedList< T >::operator[]().

virtual PINDEX PAbstractSortedList::GetObjectsIndex | ( | const PObject * | obj | ) | const
| virtual

Search the collection for the specific instance of the object.

The object pointers are compared, not the values. A binary search is employed to locate the entry.

Note that that will require value comparisons to be made to find the equivalent entry and then a final check is made with the pointers to see if they are the same instance.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Implements PCollection.

virtual PINDEX PAbstractSortedList::GetValuesIndex | ( | const PObject & | obj | ) | const
| virtual

Search the collection for the specified value of the object.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. A binary search is employed to locate the entry.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Implements PCollection.

virtual PINDEX PAbstractSortedList::Insert | ( | const PObject & | before,
|  | PObject * | obj
| ) |  |
| virtual

Add a new object to the collection.

The object is always placed in the correct ordinal position in the list. It is not placed at the specified position. The `before` parameter is ignored.

Returns
  index of the newly inserted object.

Implements PCollection.

virtual PINDEX PAbstractSortedList::InsertAt | ( | PINDEX | index,
|  | PObject * | obj
| ) |  |
| virtual

Add a new object to the collection.

The object is always placed in the correct ordinal position in the list. It is not placed at the specified position. The `index` parameter is ignored.

Returns
  index of the newly inserted object.

Implements PCollection.

void PAbstractSortedList::LeftRotate | ( | PSortedListElement * | node | ) |
| protected

virtual PBoolean PAbstractSortedList::Remove | ( | const PObject * | obj | ) |
| virtual

Remove the object from the collection.

If the AllowDeleteObjects option is set then the object is also deleted.

Note that the comparison for searching for the object in collection is made by pointer, not by value. Thus the parameter must point to the same instance of the object that is in the collection.

Returns
  true if the object was in the collection.

Implements PCollection.

virtual void PAbstractSortedList::RemoveAll | ( |  | ) |
| virtual

Remove all of the elements in the collection.

This operates by continually calling `RemoveAt()` until there are no objects left.

The objects are removed from the last, at index `(GetSize()-1)` toward the first at index zero.

Reimplemented from PCollection.

virtual PObject* PAbstractSortedList::RemoveAt | ( | PINDEX | index | ) |
| virtual

Remove the object at the specified ordinal index from the collection.

If the AllowDeleteObjects option is set then the object is also deleted.

Note if the index is beyond the size of the collection then the function will assert.

Returns
  pointer to the object being removed, or NULL if it was deleted.

Implements PCollection.

void PAbstractSortedList::RemoveElement | ( | PSortedListElement * | node | ) |
| protected

Referenced by PSortedList< T >::erase().

void PAbstractSortedList::RightRotate | ( | PSortedListElement * | node | ) |
| protected

virtual PBoolean PAbstractSortedList::SetAt | ( | PINDEX | index,
|  | PObject * | val
| ) |  |
| virtual

This method simply returns false as the list order is mantained by the class.

Kept to mimic `PAbstractList` interface.

Returns
  false allways

Implements PCollection.

virtual PBoolean PAbstractSortedList::SetSize | ( | PINDEX | newSize | ) |
| virtual

This function is meaningless for lists.

The size of the collection is determined by the addition and removal of objects. The size cannot be set in any other way.

Returns
  Always true.

Implements PContainer.

## Member Data Documentation

PSortedListInfo* PAbstractSortedList::m_info
| protected

Referenced by PSortedList< T >::begin(), and PSortedList< T >::rbegin().

The documentation for this class was generated from the following file:

- lists.h